package com.loafle.bridge.discoveryhost;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.loafle.bridge.discoveryport.DiscoveryPort;
import com.loafle.bridge.discoveryzone.DiscoveryZone;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

/**
 * Created by root on 16. 11. 15.
 */
@Entity
public class DiscoveryHost {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @Column(name = "IP",nullable = false)
    private long ip;

    @Column(name = "MAC",nullable = false)
    private long mac;

    @ManyToOne
    @JoinColumn(name = "ZONE_ID", nullable = false)
    @JsonIgnore
    private DiscoveryZone zone;

    public DiscoveryZone getZone() {
        return zone;
    }

    public void setZone(DiscoveryZone zone) {
        this.zone = zone;
    }

    @OneToMany(mappedBy = "host", cascade = CascadeType.ALL)
    private List<PortScanHistory> histories;

    public List<PortScanHistory> getHistories() {
        return histories;
    }

    public void setHistories(List<PortScanHistory> histories) {
        this.histories = histories;
    }

    @OneToMany(mappedBy = "host",cascade = CascadeType.ALL)
    private List<DiscoveryPort> ports;

    public List<DiscoveryPort> getPorts() {
        return ports;
    }

    public void setPorts(List<DiscoveryPort> ports) {
        this.ports = ports;
    }

    @Column(name = "CREATE_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false, updatable = false)
    private Date createDate;

    @Column(name = "UPDATE_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false)
    private Date updateDate;


    public DiscoveryHost(){}

    public DiscoveryHost(long ip, long mac){
        this.ip = ip;
        this.mac = mac;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public long getIp() {
        return ip;
    }

    public void setIp(long ip) {
        this.ip = ip;
    }

    public long getMac() {
        return mac;
    }

    public void setMac(long mac) {
        this.mac = mac;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    public void mappingChildren(DiscoveryZone discoveryZone) {
        this.setZone(discoveryZone);

        List<PortScanHistory> portScanHistories = this.getHistories();
        if (portScanHistories != null) {
            for (int j =0 ; j < portScanHistories.size() ; ++j) {
                portScanHistories.get(j).setHost(this);
            }
        }

        List<DiscoveryPort> ports = this.getPorts();
        if (ports != null) {
            for (int j =0 ; j < ports.size() ; ++j) {
                ports.get(j).mappingChildren(this);
            }
        }
    }
}
